#include "scaler.h"
#include <fruit/fruit.h>
  using fruit::createComponent;


class ScalerImpl: Scaler {

public:
  INJECT(ScalerImpl(ASSISTED(int) scale)): _scale(scale) { }

  ScalerImpl(const ScalerImpl&) = delete;
  ScalerImpl & operator=(const ScalerImpl &) = delete;

  int scale(int arg) override  {
    return this->_scale * arg;
  }

  int _scale;
};

Component<ScalerFactory> getScalerComponent() {
  return createComponent()
      .bind<Scaler, ScalerImpl>();
}
